$(document).ready(function () {
    $(".tbody").on("blur", ".barcode", itemModalShow);
    $(".iTbody").on("click", ".itemTr", addTrVal);
    $(".itemModal").on("keyup", ".isearch", getItemData);
    $(".itemModal").on("change", ".isortBy, iorderAS", getItemData);
    $(".inoRecord").hide();

    window.addEventListener('keydown', function (e) {
        if (e.keyIdentifier == 'U+000A' || e.keyIdentifier == 'Enter' || e.keyCode == 13) {
            if (e.target.nodeName == 'INPUT' && e.target.type == 'text' && e.target.className == "iname") {
                addTrVal(e);
            }
        }
    }, true);

    function itemModalShow() {
        var tr = $(this).closest("tr"),
                barcode = tr.find(".barcode").val();

        if (barcode == "") {
            $(".itemname").removeClass("dataItemname");
            $(".barcode").removeClass("dataBarcode");
            $(".brand").removeClass("dataBrand");
            $(".size").removeClass("dataSize");
            $(".colour").removeClass("dataColour");
            $(".unit").removeClass("dataUnit");
            $(".rate").removeClass("dataRate");
            $(".qty").removeClass("dataQty");
            $(".frame").removeClass("dataFrame");

            tr.find(".itemname").addClass("dataItemname");
            tr.find(".barcode").addClass("dataBarcode");
            tr.find(".brand").addClass("dataBrand");
            tr.find(".size").addClass("dataSize");
            tr.find(".colour").addClass("dataColour");
            tr.find(".unit").addClass("dataUnit");
            tr.find(".rate").addClass("dataRate");
            tr.find(".qty").addClass("dataQty");
            tr.find(".frame").addClass("dataFrame");
            $(".itemModal").modal("show");
            getItemData();
        } else {
            $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_ibarcode.php",
                data: {barcode: barcode},
                success: function (response) {
                    var m = response;

                    tr.find(".itemname").val(m.name);
                    tr.find(".brand").val(m.brand);
                    tr.find(".size").val(m.size);
                    tr.find(".colour").val(m.colour);
                    tr.find(".unit").val(m.unit);
                    tr.find(".rate").val(m.rate);
                    if (m.frame == 1) {
                        tr.find(".frame").attar("required", true);
                    }
                    tr.find(".qty").focus();

                },
                error: function (request, textStatus, errorThrown) {

                }
            });
        }
    }

    $(".itemModal").on('shown.bs.modal', function () {
        $(".isearch").focus();
        $(".isearch").val("");
        $(".ifield").val("1");
        getItemData();
    });

    $(".itemModal").on('hidden.bs.modal', function () {
        $(".dataRate").focus();
        $(".dataRate").select();
    });

    var imrangeFrom = 0,
            imrangeTo = 40;

    function getItemData(pagination) {

        $(".iloader").show();

        if (pagination == 'prev') {
            if (imrangeFrom > 0) {
                imrangeFrom = (imrangeFrom - 40);
                imrangeTo = (imrangeTo - 40);
            }
        }
        if (pagination == 'next') {
            imrangeFrom = (imrangeFrom + 40);
            imrangeTo = (imrangeTo + 40);
        }

        var series = $(".series").val(),
                vouchno = $(".vouchno").val(),
                file = $(".file").val(),
                isearch = $(".isearch").val(),
                ifield = $(".ifield").val(),
                ioperator = $(".ioperator").val(),
                sortBy = $(".isortBy").val(),
                orderAs = $(".iorderBy").val(),
                data = {isearch: isearch, ifield: ifield, ioperator: ioperator, sortBy: sortBy, orderAs: orderAs,
                        series: series, vouchno: vouchno, file: file, rangeFrom: imrangeFrom, rangeTo: imrangeTo},
        values = "";
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "search_item.php",
            data: data,
            success: function (response) {
                $.each(response, function () {
                    values += "<tr class='itemTr'>" +
                            "<td align='left'><input type='text' class='iname' value='" + this.name + "' readonly style='width:100%'></td>" +
                            "<td align='left'><input type='text' class='ibarcode' value='" + this.barcode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='ibrand' value='" + this.brand + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='isize' value='" + this.size + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='icolour' value='" + this.colour + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iunit' value='" + this.unit + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<input type='hidden' class='iframe' value='" + this.frame + "'>" +
                            "<td align='left'><input type='text' class='irate' value='" + this.rate + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "</tr>";
                });
                $(".iloader").hide();
                $(".iTbody").empty();
                $(".iTbody").html(values);
                if (response) {
                    $(".search-action-bar").show();
                }
            },
            error: function (request, textStatus, errorThrown) {

            }
        });
    }
    $(".iload").click(function () {
        getItemData();
    });
//    $(".isearch").change(function () {
//        getItemData();
//    });
    $(".iprevious").click(function () {
        getItemData('prev');
    });
    $(".inext").click(function () {
        getItemData('next');
    });

    function addTrVal(e) {
        var tr = "";
        if (e == "undefined") {
            tr = $(this).closest("tr");
        } else {
            tr = $(e.target).closest("tr");
        }

        var iname = tr.find(".iname").val(),
                ibarcode = tr.find(".ibarcode").val(),
                ibrand = tr.find(".ibrand").val(),
                isize = tr.find(".isize").val(),
                icolour = tr.find(".icolour").val(),
                iunit = tr.find(".iunit").val(),
                irate = tr.find(".irate").val(),
                iframe = tr.find(".iframe").val();



        $(".dataItemname").val(iname);
        $(".dataBarcode").val(ibarcode);
        $(".dataBrand").val(ibrand);
        $(".dataSize").val(isize);
        $(".dataColour").val(icolour);
        $(".dataUnit").val(iunit);
        $(".dataRate").val(irate);
        if (iframe == 1) {
            $(".dataFrame").attr("required", true);
        }

        $(".dataItemname").removeClass('dataItemname');
        $(".dataBarcode").removeClass('dataBarcode');
        $(".dataBrand").removeClass('dataBrand');
        $(".dataSize").removeClass("dataSize");
        $(".dataColour").removeClass("dataColour");
        $(".dataUnit").removeClass("dataUnit");
        $(".dataQty").removeClass("dataQty");

        $(".itemModal").modal("hide");

    }


    $(".rate").blur(function () {
        $(".dataRate").removeClass("dataRate");
    });
});